﻿/*
  ライブラリを使用するための雛形
*/

// dllを動的にロードする場合は「_DYNAMICLOAD」を
// dx2lib.hをインクルードする前に宣言
//#define _DYNAMICLOAD

#include  <stdio.h>
#include  "dx2lib.h"  // Dynamixelライブラリのヘッダ

// マクロ定義
#define COMPORT   "\\\\.\\COM5" // ポート番号
#define BAUDRATE  (57600)       // ボーレート[bps]

void main (void) {
  // デバイスID (COMポート毎のユニークな値)
  TDeviceID  dev;

#ifdef _DYNAMICLOAD
  // DLLをロード
  if (LoadDLL()) {
#endif

    // 指定されたパラメータでポートを開く
    // 成功すれば0以外のユニークな値(デバイスID)が返される
    // 以後このデバイスIDを使用する
    dev = DX2_OpenPort (COMPORT, BAUDRATE);
    // オープン直後に通信を開始すると挙動が怪しいI/Fがあるので少し待つことを推奨
    // 問題ない環境であれば削除して構わない
    Sleep (1000);

    // devが0でなければポートを開く事に成功
    if (dev) {
      printf ("Open success\n");

      // ----ここにやりたい事を書く------------


      // --------------------------------------

      // 使い終わったポートは必ず閉じる
      DX2_ClosePort (dev);

    } else {
      printf ("Open error\n");
    }
#ifdef _DYNAMICLOAD
    // DLLをアンロード
    UnloadDLL();
  }
#endif

  printf ("Fin\n");
}
