﻿/*
  DXL APIを使う
   角度指令
*/

#include <stdio.h>
#include "dx2lib.h"

#define COMPORT     "\\\\.\\COM5"   // ポート番号
#define BAUDRATE    (57600)         // ボーレート[bps]
#define TARGETID    (1)             // 対象となるID

//===========================================================
// メイン
//===========================================================
void main (void) {
  TDeviceID dev = DX2_OpenPort (COMPORT, BAUDRATE);

  if (dev != 0) {
    printf ("Open success\n");

    // 指定IDのデバイス情報を取得
    // モデルNo.が既存のDynamixelと一致しないと以後機能しない
    printf ("[id:%d] Model Name=%s\n", TARGETID, DXL_GetModelInfo (dev, TARGETID)->name);

    // マルチターンJointモードに設定
    if (DXL_SetOperatingMode (dev, TARGETID, 4)) {
      // LED点灯
      DXL_SetLED (dev, TARGETID, true);
      // トルクイネーブル
      DXL_SetTorqueEnable (dev, TARGETID, true);

      DXL_SetGoalAngle (dev, TARGETID, 720.0);   // 720deg
      Sleep (5000);
      DXL_SetGoalAngle (dev, TARGETID, -720.0);  // -720deg
      Sleep (10000);
      DXL_SetGoalAngle (dev, TARGETID, 0.0);    // 0deg
      Sleep (5000);

      // トルクディスエーブル
      DXL_SetTorqueEnable (dev, TARGETID, false);
      // LED消灯
      DXL_SetLED (dev, TARGETID, false);
    } else {
      printf ("SetOPmode error\n");
    }
    DX2_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }
}
