﻿/*
  PINGでネットワーク上の対象を検索

  ターゲット:PRO+, PRO, X, MX, XL320
*/

#include  <stdio.h>
#include  "dx2lib.h"
#include  "kbhit.h"

// マクロ定義
#define COMPORT   "/dev/ttyUSB0"  // ポート名
#define BAUDRATE  (57600)         // ボーレート[bps]

int main (void) {
  TDeviceID   dev;
  TErrorCode  err;

  if ((dev = DX2_OpenPort (COMPORT, BAUDRATE))) {
    //DX2_SetTimeOutOffset (dev, 200);
    printf ("Open success\n");

    // ID=0～253もしくはキー入力があるまで検索
    enable_raw_mode ();
    for (int i = 0; (i <= 253) && !kbhit(); i++) {
      // 指定したIDのデバイスがあるかどうか確認
      if (DX2_Ping (dev, i, &err)) printf ("\rFound     ID=%3d [$%04X]\n", i, err);
      else                         printf ("\rNot found ID=%3d [$%04X]", i, err);
    }
    disable_raw_mode ();

    DX2_ClosePort (dev);
  } else printf ("Open error\n");

  printf ("\nFin\n");
  tty_flush ();
}
