﻿/*
  PING2でネットワーク上の対象を検索

  ターゲット:PRO+, PRO, X, MX, XL320
*/

#include  <stdio.h>
#include  "dx2lib.h"

// マクロ定義
#define COMPORT   "/dev/ttyUSB0"  // ポート名
#define BAUDRATE  (57600)         // ボーレート[bps]

int main (void) {
  TDeviceID   dev;
  TErrorCode  err;
  uint32_t    num;          // 最大検索数と検索結果
  TDx2AlarmStatus alm[254]; // 検索結果の保存先

  if ((dev = DX2_OpenPort (COMPORT, BAUDRATE))) {
    printf ("Open success\n");

    num = 254;

    if (DX2_Ping2 (dev, &num, alm, &err)) {
      for (int i = 0; i < num; i++) printf ("\rFound     ID=%3d [$%04X]\n", alm[i].id, alm[i].Status);
    } else printf ("\rNot found [$%04X]", err);

    DX2_ClosePort (dev);
  } else printf ("Open error\n");

  printf ("\nFin\n");
}
